#
# TODO:
# - investigate build-time vs runtime CPU features detection
#
# Conditional build:
%bcond_without	opencl		# OpenCL support
%bcond_without	openmp		# OpenMP support

%define		snap		20211017
%define		githash		9298dec7259141f15729fa289411c5033a2fe3aa
%define		rel		2

Summary:	Password cracker
Summary(pl.UTF-8):	Łamacz haseł
Name:		john
Version:	1.9.0
Release:	1.%{snap}.%{rel}
License:	GPL v2
Group:		Applications/System
Source0:	https://github.com/magnumripper/JohnTheRipper/archive/%{githash}/%{name}-%{snap}.tar.gz
# Source0-md5:	50e53c990a5083d0ccb4d1175c1a7d3d
Patch0:		%{name}-mailer.patch
Patch1:		jumbo-optflags.patch
Patch2:		%{name}-x32.patch
URL:		http://www.openwall.com/john/
%{?with_opencl:BuildRequires:	OpenCL-devel}
BuildRequires:	autoconf >= 2.69
BuildRequires:	bzip2-devel
%{?with_openmp:BuildRequires:	gcc >= 6:4.2}
BuildRequires:	gmp-devel
%{?with_openmp:BuildRequires:	libgomp-devel}
BuildRequires:	rpmbuild(macros) >= 1.213
BuildRequires:	tar >= 1:1.22
# for SIPdump and vncpcap2john binaries, which are not packaged
#BuildRequires:	libpcap-devel
BuildRequires:	openssl-devel >= 0.9.7
BuildRequires:	pkgconfig
BuildRequires:	yasm
BuildRequires:	zlib-devel
Requires:	words
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
John the Ripper is a fast password cracker, currently available for
many flavors of Unix (11 are officially supported, not counting
different architectures), DOS, Win32, BeOS, and OpenVMS (the latter
requires a contributed patch). Its primary purpose is to detect weak
Unix passwords. Besides several crypt(3) password hash types most
commonly found on various Unix flavors, supported out of the box are
Kerberos/AFS and Windows NT/2000/XP LM hashes, plus several more with
contributed patches.

%description -l pl.UTF-8
John The Ripper jest szybkim "łamaczem" haseł dostępnym dla wielu
rodzajów uniksów (oficjalnie obsługiwanych jest 11, nie licząc różnych
architektur), DOS-a, Win32, BeOS-a i OpenVMS-a (ten ostatni wymaga
łaty). Głównym zastosowaniem jest wykrywanie słabych haseł uniksowych.
Oprócz różnych rodzajów skrótów haseł crypt(3) najczęściej używanych
na różnych uniksach, obsługiwane są także skróty Kerberos/AFS oraz
Windows NT/2000/XP LM, a także kilka innych przy użyciu łat.

%prep
%setup -q -n john-%{githash}
%patch0 -p1
%patch1 -p1
%ifarch x32
%patch2 -p1
%endif

%build
cd src
%{__autoconf}

%ifarch x32
ax_intel_x32=yes \
%endif
%configure \
	%{!?with_opencl:--disable-opencl} \
	%{!?with_openmp:--disable-openmp}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/john}
cp -a run/{*.conf,*.chr,*.lst} $RPM_BUILD_ROOT%{_datadir}/john
install -p run/john $RPM_BUILD_ROOT%{_bindir}

ln -sf john $RPM_BUILD_ROOT%{_bindir}/unafs
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unique
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unshadow

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc doc/* run/mailer
%attr(755,root,root) %{_bindir}/john
%attr(755,root,root) %{_bindir}/unafs
%attr(755,root,root) %{_bindir}/unique
%attr(755,root,root) %{_bindir}/unshadow
%{_datadir}/john
%changelog
* Sun Oct 17 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/john.git;a=log;h=master

* Sun Oct 17 2021 Jan Rękorajski <baggins@pld-linux.org> 15da831
- updated to latest snap, rel 2

* Wed Oct 06 2021 Jan Rękorajski <baggins@pld-linux.org> d92a384
- rediff patch

* Tue Apr 16 2019 Adam Gołębiowski <adamg@pld-linux.org> 051c645
- updated to 1.9.0 snap 201904115 (githash af81c8de)

* Wed Mar 27 2019 Adam Gołębiowski <adamg@pld-linux.org> 70a2594
- updated to 20190327 snap (githash 4840892d)

* Mon Nov 05 2018 Jan Rękorajski <baggins@pld-linux.org> 8de67df
- relup friendly release 2

* Mon Nov 05 2018 Adam Gołębiowski <adamg@pld-linux.org> 5529214
- cosmetic changes in todo, bconds desc

* Mon Nov 05 2018 Adam Gołębiowski <adamg@pld-linux.org> b1820b0
- adapterized

* Mon Nov 05 2018 Adam Gołębiowski <adamg@pld-linux.org> bbd8a45
- todo

* Mon Nov 05 2018 Adam Gołębiowski <adamg@pld-linux.org> e929c19
- no longer needed

* Sun Nov 04 2018 Adam Gołębiowski <adamg@pld-linux.org> 4c0cf90
- this chunk seems no longer needed

* Sun Nov 04 2018 Adam Gołębiowski <adamg@pld-linux.org> c087c84
- merged into john-x32.patch

* Sun Nov 04 2018 Adam Gołębiowski <adamg@pld-linux.org> f159827
- updated to 20181101 git snap (combined "core" and "jumbo")
- massively simplify spec file - drop all non-jumbo chunks in spec file,
  or settings for unsupported archs

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> d3542e6
- release 2 (by relup.sh)

* Sun Mar 06 2016 Jakub Bogusz <qboosh@pld-linux.org> bd15433
- renamed gomp bcond to compiler-agnostic openmp

* Sun Aug 30 2015 Jakub Bogusz <qboosh@pld-linux.org> b282b6d
- added jumbo version dependencies, gomp and opencl bconds

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 4b4e0bd
- fix building on x32
- fix jumbo bcond and macros

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 057ac04
- more if jumbo

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 0d881e9
- when building jumbo version, configure decidec what cpu features to build

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 07bb911
- restore source2-md5

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 2489275
- added jumbo tarbal and enabled it as default build
- rel 1

